Right-to-Left Support
The DevExtreme Navigation components support right-to-left (RTL) languages. The components can display content in a right-to-left direction and mirror associated UI elements.
To enable RTL language support in the application, you can either set the globalConfig object's rtlEnabled property to true or specify each component's rtlEnabled property individually. Note that individual RTL parameters have higher priority than general parameters.
In this demo, you can use the language drop-down menu (for example, change the language from English to Arabic) to explore the differences between default and RTL modes.
Feel free to share demo-related thoughts here.
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Thank you for the feedback!
If you have technical questions, please create a support ticket in the DevExpress Support Center.
Backend API
$(() => {
DevExpress.setTemplateEngine({
compile: (element) => $(element).html(),
render: (template, data) => Mustache.render(template, data),
});
const treeViewWidget = $('#treeview').dxTreeView({
dataSource: continents,
width: 200,
displayExpr: 'text',
}).dxTreeView('instance');
const menuWidget = $('#menu').dxMenu({
dataSource: continents,
}).dxMenu('instance');
const arabicAccordionOptions = {
rtlEnabled: true,
itemTitleTemplate(data, index, element) {
const $item = $('<div>').text(data.nameAr);
element.append($item);
},
itemTemplate: $('#arabic-accordion-template'),
};
const englishAccordionOptions = {
rtlEnabled: false,
itemTitleTemplate(data, index, element) {
const $item = $('<div>').text(data.nameEn);
element.append($item);
},
itemTemplate: $('#english-accordion-template'),
};
const accordionWidget = $('#accordion').dxAccordion(
$.extend({
dataSource: europeCountries,
},
englishAccordionOptions),
).dxAccordion('instance');
const languages = [
'Arabic: Right-to-Left direction',
'English: Left-to-Right direction',
];
$('#select-language').dxSelectBox({
items: languages,
value: languages[1],
inputAttr: { 'aria-label': 'Language' },
onValueChanged(data) {
const isRTL = data.value === languages[0];
$('.demo-container').toggleClass('dx-rtl', isRTL);
$.each([treeViewWidget, menuWidget], (_, instance) => {
instance.option('rtlEnabled', isRTL);
instance.option('displayExpr', isRTL ? 'textAr' : 'text');
});
accordionWidget.option(isRTL
? arabicAccordionOptions
: englishAccordionOptions);
},
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/23.1.6/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/23.1.6/js/dx.all.js"></script>
<script src="https://unpkg.com/mustache@2.3.2/mustache.min.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div class="options">
<div class="caption">Options</div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Language</div>
<div class="dx-field-value">
<div id="select-language"></div>
</div>
</div>
</div>
</div>
<div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">
<div id="menu"></div>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">
<div id="treeview"></div>
</div>
<div class="dx-field-value">
<div id="accordion"></div>
</div>
</div>
</div>
</div>
<script type="text/html" id="arabic-accordion-template">
<div>
<div>عاصمة: {{ capitalAr }} </div>
<div>عدد السكان: {{ population }} نسمة</div>
<div>المساحة: {{ area }} كم<sup>2</sup></div>
</div>
</script>
<script type="text/html" id="english-accordion-template">
<div>
<div>Capital: {{ capitalEn }} </div>
<div>Population: {{ population }} people</div>
<div>Area: {{ area }} km<sup>2</sup></div>
</div>
</script>
</div>
</body>
</html>
sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-bottom: 20px;
}
.options .dx-fieldset {
margin: 0;
}
.caption {
font-size: 18px;
font-weight: 500;
padding-right: 15px;
}
.dx-theme-material .dx-accordion .dx-accordion-item-opened .dx-accordion-item-title {
padding-top: 20px;
}
const continents = [{
id: '1',
text: 'Africa',
textAr: 'أفريقيا',
items: [
{
id: '1_2',
text: 'Ethiopia',
textAr: 'أثيوبيا',
items: [{
id: '1_2_1',
text: 'Addis Ababa',
textAr: 'أديس أبابا',
}, {
id: '1_2_2',
text: 'Dire Dawa',
textAr: 'دير داوا',
}],
},
{
id: '1_1',
text: 'Nigeria',
textAr: 'نيجيريا',
items: [{
id: '1_1_1',
text: 'Lagos',
textAr: 'لاغوس',
}, {
id: '1_1_2',
text: 'Kano',
textAr: 'كانو',
}],
},
],
}, {
id: '2',
text: 'Asia',
textAr: 'آسيا',
items: [{
id: '2_1',
text: 'China',
textAr: 'الصين',
items: [{
id: '2_1_1',
text: 'Beijing',
textAr: 'بكين',
}, {
id: '2_1_2',
text: 'Shanghai',
textAr: 'شنغهاي',
}],
}, {
id: '2_2',
text: 'India',
textAr: 'الهند',
items: [{
id: '2_2_1',
text: 'Indianapolis',
textAr: 'انديانابوليس',
}, {
id: '2_2_2',
text: 'New Delhi',
textAr: 'نيودلهي',
}],
}],
}, {
id: '3',
text: 'Australia',
textAr: 'أستراليا',
items: [{
id: '3_1',
text: 'Australia',
textAr: 'أستراليا',
items: [{
id: '3_1_1',
text: 'Canberra',
textAr: 'كانبيرا',
}, {
id: '3_1_2',
text: 'Melbourne',
textAr: 'ملبورن',
}, {
id: '3_1_3',
text: 'Sydney',
textAr: 'سيدني',
}],
}],
}, {
id: '4',
text: 'Europe',
textAr: 'أوروبا',
items: [{
id: '4_1',
text: 'Germany',
textAr: 'ألمانيا',
items: [{
id: '4_1_1',
text: 'Berlin',
textAr: 'البرلينية',
}, {
id: '4_1_2',
text: 'Hamburg',
textAr: 'هامبورغ',
}],
}, {
id: '4_2',
text: 'Russia',
textAr: 'روسيا',
items: [{
id: '4_2_1',
text: 'Moscow',
textAr: 'موسكو',
}, {
id: '4_2_2',
text: 'Saint Petersburg',
textAr: 'سانت بطرسبرغ',
}],
}],
}, {
id: '5',
text: 'North America',
textAr: 'أمريكا الشمالية',
items: [{
id: '5_2',
text: 'Mexico',
textAr: 'المكسيك',
items: [{
id: '5_2_1',
text: 'Mexico City',
textAr: 'مكسيكو سيتي',
}, {
id: '5_2_2',
text: 'Guadalajara',
textAr: 'غوادالاخارا',
}],
}, {
id: '5_1',
text: 'United States',
textAr: 'الولايات المتحدة الأمريكية',
items: [{
id: '5_1_1',
text: 'New York',
textAr: 'نيويورك',
}, {
id: '5_1_2',
text: 'Washington',
textAr: 'واشنطن',
}],
}],
}, {
id: '6',
text: 'South America',
textAr: 'أمريكا الجنوبية',
items: [{
id: '6_1',
text: 'Brazil',
textAr: 'البرازيل',
items: [{
id: '6_1_1',
text: 'Brasilia',
textAr: 'برازيليا',
}, {
id: '6_1_2',
text: 'Sao Paulo',
textAr: 'ساو باولو',
}],
}, {
id: '6_2',
text: 'Colombia',
textAr: 'كولومبيا',
items: [{
id: '6_2_1',
text: 'Bogota',
textAr: 'بوغوتا',
}, {
id: '6_2_2',
text: 'Medellin',
textAr: 'ميديلين',
}],
}],
}];
const europeCountries = [{
nameAr: 'النمسا',
nameEn: 'Austria',
population: 8451900,
area: 83855.0,
capitalEn: 'Vienna',
capitalAr: 'فيينا',
}, {
nameAr: 'بلجيكا',
nameEn: 'Belgium',
population: 11161600,
area: 30528.0,
capitalEn: 'Brussels',
capitalAr: 'بروكسل',
}, {
nameAr: 'بلغاريا',
nameEn: 'Bulgaria',
population: 7284600,
area: 110994.0,
capitalEn: 'Sofia',
capitalAr: 'صوفيا',
}, {
nameAr: 'كرواتيا',
nameEn: 'Croatia',
population: 4262100,
area: 56594.0,
capitalEn: 'Zagreb',
capitalAr: 'زغرب',
}];

Backend API
<template>
<div :class="{ 'dx-rtl': rtlEnabled }">
<div class="options">
<div class="caption">Options</div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Language</div>
<div class="dx-field-value">
<DxSelectBox
:items="languages"
:value="languages[1]"
:input-attr="{ 'aria-label': 'Language' }"
@valueChanged="selectLanguage($event)"
/>
</div>
</div>
</div>
</div>
<div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">
<DxMenu
:data-source="continents"
:rtl-enabled="rtlEnabled"
:display-expr="rtlEnabled ? 'textAr' : 'text'"
/>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">
<DxTreeView
:width="200"
:data-source="continents"
:display-expr="rtlEnabled ? 'textAr' : 'text'"
:rtl-enabled="rtlEnabled"
/>
</div>
<div class="dx-field-value">
<DxAccordion
:data-source="europeCountries"
:rtl-enabled="rtlEnabled"
:item-title-template="rtlEnabled ? 'arabic-title' : 'english-title'"
:item-template="rtlEnabled ? 'arabic' : 'english'"
>
<template #arabic-title="{ data }">
{{ data.nameAr }}
</template>
<template #arabic="{ data }">
<div>عاصمة: {{ data.capitalAr }} </div>
<div>عدد السكان: {{ data.population }} نسمة</div>
<div>المساحة: {{ data.area }} كم<sup>2</sup></div>
</template><template #english-title="{ data }">
{{ data.nameEn }}
</template>
<template #english="{ data }">
<div>Capital: {{ data.capitalEn }} </div>
<div>Population: {{ data.population }} people</div>
<div>Area: {{ data.area }} km<sup>2</sup></div>
</template>
</DxAccordion>
</div>
</div>
</div>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxSelectBox, { type DxSelectBoxTypes } from 'devextreme-vue/select-box';
import DxMenu from 'devextreme-vue/menu';
import DxTreeView from 'devextreme-vue/tree-view';
import DxAccordion from 'devextreme-vue/accordion';
import { continents, europeCountries } from './data.ts';
const languages = [
'Arabic: Right-to-Left direction',
'English: Left-to-Right direction',
];
const rtlEnabled = ref(false);
function selectLanguage(e: DxSelectBoxTypes.ValueChangedEvent) {
rtlEnabled.value = e.value === languages[0];
}
</script>
<style scoped>
sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-bottom: 20px;
}
.options .dx-fieldset {
margin: 0;
}
.caption {
font-size: 18px;
font-weight: 500;
padding-right: 15px;
}
.dx-theme-material .dx-accordion .dx-accordion-item-opened .dx-accordion-item-title {
padding-top: 20px;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.4.27/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export const continents = [{
id: '1',
text: 'Africa',
textAr: 'أفريقيا',
items: [
{
id: '1_2',
text: 'Ethiopia',
textAr: 'أثيوبيا',
items: [{
id: '1_2_1',
text: 'Addis Ababa',
textAr: 'أديس أبابا',
}, {
id: '1_2_2',
text: 'Dire Dawa',
textAr: 'دير داوا',
}],
},
{
id: '1_1',
text: 'Nigeria',
textAr: 'نيجيريا',
items: [{
id: '1_1_1',
text: 'Lagos',
textAr: 'لاغوس',
}, {
id: '1_1_2',
text: 'Kano',
textAr: 'كانو',
}],
},
],
}, {
id: '2',
text: 'Asia',
textAr: 'آسيا',
items: [{
id: '2_1',
text: 'China',
textAr: 'الصين',
items: [{
id: '2_1_1',
text: 'Beijing',
textAr: 'بكين',
}, {
id: '2_1_2',
text: 'Shanghai',
textAr: 'شنغهاي',
}],
}, {
id: '2_2',
text: 'India',
textAr: 'الهند',
items: [{
id: '2_2_1',
text: 'Indianapolis',
textAr: 'انديانابوليس',
}, {
id: '2_2_2',
text: 'New Delhi',
textAr: 'نيودلهي',
}],
}],
}, {
id: '3',
text: 'Australia',
textAr: 'أستراليا',
items: [{
id: '3_1',
text: 'Australia',
textAr: 'أستراليا',
items: [{
id: '3_1_1',
text: 'Canberra',
textAr: 'كانبيرا',
}, {
id: '3_1_2',
text: 'Melbourne',
textAr: 'ملبورن',
}, {
id: '3_1_3',
text: 'Sydney',
textAr: 'سيدني',
}],
}],
}, {
id: '4',
text: 'Europe',
textAr: 'أوروبا',
items: [{
id: '4_1',
text: 'Germany',
textAr: 'ألمانيا',
items: [{
id: '4_1_1',
text: 'Berlin',
textAr: 'البرلينية',
}, {
id: '4_1_2',
text: 'Hamburg',
textAr: 'هامبورغ',
}],
}, {
id: '4_2',
text: 'Russia',
textAr: 'روسيا',
items: [{
id: '4_2_1',
text: 'Moscow',
textAr: 'موسكو',
}, {
id: '4_2_2',
text: 'Saint Petersburg',
textAr: 'سانت بطرسبرغ',
}],
}],
}, {
id: '5',
text: 'North America',
textAr: 'أمريكا الشمالية',
items: [{
id: '5_2',
text: 'Mexico',
textAr: 'المكسيك',
items: [{
id: '5_2_1',
text: 'Mexico City',
textAr: 'مكسيكو سيتي',
}, {
id: '5_2_2',
text: 'Guadalajara',
textAr: 'غوادالاخارا',
}],
}, {
id: '5_1',
text: 'United States',
textAr: 'الولايات المتحدة الأمريكية',
items: [{
id: '5_1_1',
text: 'New York',
textAr: 'نيويورك',
}, {
id: '5_1_2',
text: 'Washington',
textAr: 'واشنطن',
}],
}],
}, {
id: '6',
text: 'South America',
textAr: 'أمريكا الجنوبية',
items: [{
id: '6_1',
text: 'Brazil',
textAr: 'البرازيل',
items: [{
id: '6_1_1',
text: 'Brasilia',
textAr: 'برازيليا',
}, {
id: '6_1_2',
text: 'Sao Paulo',
textAr: 'ساو باولو',
}],
}, {
id: '6_2',
text: 'Colombia',
textAr: 'كولومبيا',
items: [{
id: '6_2_1',
text: 'Bogota',
textAr: 'بوغوتا',
}, {
id: '6_2_2',
text: 'Medellin',
textAr: 'ميديلين',
}],
}],
}];
export const europeCountries = [{
nameAr: 'النمسا',
nameEn: 'Austria',
population: 8451900,
area: 83855.0,
capitalEn: 'Vienna',
capitalAr: 'فيينا',
}, {
nameAr: 'بلجيكا',
nameEn: 'Belgium',
population: 11161600,
area: 30528.0,
capitalEn: 'Brussels',
capitalAr: 'بروكسل',
}, {
nameAr: 'بلغاريا',
nameEn: 'Bulgaria',
population: 7284600,
area: 110994.0,
capitalEn: 'Sofia',
capitalAr: 'صوفيا',
}, {
nameAr: 'كرواتيا',
nameEn: 'Croatia',
population: 4262100,
area: 56594.0,
capitalEn: 'Zagreb',
capitalAr: 'زغرب',
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
To enable RTL language support in the application, you can either set the globalConfig object's rtlEnabled property to true or specify each component's rtlEnabled property individually. Note that individual RTL parameters have higher priority than general parameters.
In this demo, you can use the language drop-down menu (for example, change the language from English to Arabic) to explore the differences between default and RTL modes.

Backend API
<div [class]="{ 'dx-rtl': rtlEnabled }">
<div class="options">
<div class="caption">Options</div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">Language</div>
<div class="dx-field-value">
<dx-select-box
[items]="languages"
[inputAttr]="{ 'aria-label': 'Language' }"
[value]="languages[1]"
(onValueChanged)="selectLanguage($event)"
></dx-select-box>
</div>
</div>
</div>
</div>
<div>
<div class="dx-fieldset">
<div class="dx-fieldset-header">
<dx-menu
[dataSource]="continents"
[rtlEnabled]="rtlEnabled"
[displayExpr]="rtlEnabled ? 'textAr' : 'text'"
></dx-menu>
</div>
</div>
<div class="dx-fieldset">
<div class="dx-field">
<div class="dx-field-label">
<dx-tree-view
[width]="200"
[dataSource]="continents"
[displayExpr]="rtlEnabled ? 'textAr' : 'text'"
[rtlEnabled]="rtlEnabled"
></dx-tree-view>
</div>
<div class="dx-field-value">
<dx-accordion
[dataSource]="europeCountries"
[rtlEnabled]="rtlEnabled"
[itemTitleTemplate]="rtlEnabled ? 'arabicTitle' : 'englishTitle'"
[itemTemplate]="rtlEnabled ? 'arabic' : 'english'"
>
<div *dxTemplate="let item of 'arabicTitle'">
{{ item.nameAr }}
</div>
<div *dxTemplate="let country of 'arabic'">
<div>عاصمة: {{ country.capitalAr }} </div>
<div>عدد السكان: {{ country.population }} نسمة</div>
<div>المساحة: {{ country.area }} كم<sup>2</sup></div>
</div>
<div *dxTemplate="let item of 'englishTitle'">
{{ item.nameEn }}
</div>
<div *dxTemplate="let country of 'english'">
<div>Capital: {{ country.capitalEn }} </div>
<div>Population: {{ country.population }} people</div>
<div>Area: {{ country.area }} km<sup>2</sup></div>
</div>
</dx-accordion>
</div>
</div>
</div>
</div>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import {
DxAccordionModule,
DxSelectBoxModule,
DxMenuModule,
DxTreeViewModule,
} from 'devextreme-angular';
import { Continent, EuropeCountry, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
providers: [Service],
imports: [
DxAccordionModule,
DxSelectBoxModule,
DxMenuModule,
DxTreeViewModule,
],
})
export class AppComponent {
continents: Continent[];
europeCountries: EuropeCountry[];
languages: string[] = [
'Arabic: Right-to-Left direction',
'English: Left-to-Right direction',
];
rtlEnabled = false;
constructor(service: Service) {
this.continents = service.getContinents();
this.europeCountries = service.getEuropeCountries();
}
selectLanguage(e) {
this.rtlEnabled = e.value === this.languages[0];
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-bottom: 20px;
}
::ng-deep .options .dx-fieldset {
margin: 0;
}
.caption {
font-size: 18px;
font-weight: 500;
padding-right: 15px;
}
::ng-deep .dx-theme-material .dx-accordion .dx-accordion-item-opened .dx-accordion-item-title {
padding-top: 20px;
}
import { Injectable } from '@angular/core';
export class Continent {
id: string;
text: string;
textAr: string;
items?: Continent[];
}
export class EuropeCountry {
nameAr: string;
nameEn: string;
population: number;
area: number;
capitalAr: string;
capitalEn: string;
}
const continents: Continent[] = [{
id: '1',
text: 'Africa',
textAr: 'أفريقيا',
items: [
{
id: '1_2',
text: 'Ethiopia',
textAr: 'أثيوبيا',
items: [{
id: '1_2_1',
text: 'Addis Ababa',
textAr: 'أديس أبابا',
}, {
id: '1_2_2',
text: 'Dire Dawa',
textAr: 'دير داوا',
}],
},
{
id: '1_1',
text: 'Nigeria',
textAr: 'نيجيريا',
items: [{
id: '1_1_1',
text: 'Lagos',
textAr: 'لاغوس',
}, {
id: '1_1_2',
text: 'Kano',
textAr: 'كانو',
}],
},
],
}, {
id: '2',
text: 'Asia',
textAr: 'آسيا',
items: [{
id: '2_1',
text: 'China',
textAr: 'الصين',
items: [{
id: '2_1_1',
text: 'Beijing',
textAr: 'بكين',
}, {
id: '2_1_2',
text: 'Shanghai',
textAr: 'شنغهاي',
}],
}, {
id: '2_2',
text: 'India',
textAr: 'الهند',
items: [{
id: '2_2_1',
text: 'Indianapolis',
textAr: 'انديانابوليس',
}, {
id: '2_2_2',
text: 'New Delhi',
textAr: 'نيودلهي',
}],
}],
}, {
id: '3',
text: 'Australia',
textAr: 'أستراليا',
items: [{
id: '3_1',
text: 'Australia',
textAr: 'أستراليا',
items: [{
id: '3_1_1',
text: 'Canberra',
textAr: 'كانبيرا',
}, {
id: '3_1_2',
text: 'Melbourne',
textAr: 'ملبورن',
}, {
id: '3_1_3',
text: 'Sydney',
textAr: 'سيدني',
}],
}],
}, {
id: '4',
text: 'Europe',
textAr: 'أوروبا',
items: [{
id: '4_1',
text: 'Germany',
textAr: 'ألمانيا',
items: [{
id: '4_1_1',
text: 'Berlin',
textAr: 'البرلينية',
}, {
id: '4_1_2',
text: 'Hamburg',
textAr: 'هامبورغ',
}],
}, {
id: '4_2',
text: 'Russia',
textAr: 'روسيا',
items: [{
id: '4_2_1',
text: 'Moscow',
textAr: 'موسكو',
}, {
id: '4_2_2',
text: 'Saint Petersburg',
textAr: 'سانت بطرسبرغ',
}],
}],
}, {
id: '5',
text: 'North America',
textAr: 'أمريكا الشمالية',
items: [{
id: '5_2',
text: 'Mexico',
textAr: 'المكسيك',
items: [{
id: '5_2_1',
text: 'Mexico City',
textAr: 'مكسيكو سيتي',
}, {
id: '5_2_2',
text: 'Guadalajara',
textAr: 'غوادالاخارا',
}],
}, {
id: '5_1',
text: 'United States',
textAr: 'الولايات المتحدة الأمريكية',
items: [{
id: '5_1_1',
text: 'New York',
textAr: 'نيويورك',
}, {
id: '5_1_2',
text: 'Washington',
textAr: 'واشنطن',
}],
}],
}, {
id: '6',
text: 'South America',
textAr: 'أمريكا الجنوبية',
items: [{
id: '6_1',
text: 'Brazil',
textAr: 'البرازيل',
items: [{
id: '6_1_1',
text: 'Brasilia',
textAr: 'برازيليا',
}, {
id: '6_1_2',
text: 'Sao Paulo',
textAr: 'ساو باولو',
}],
}, {
id: '6_2',
text: 'Colombia',
textAr: 'كولومبيا',
items: [{
id: '6_2_1',
text: 'Bogota',
textAr: 'بوغوتا',
}, {
id: '6_2_2',
text: 'Medellin',
textAr: 'ميديلين',
}],
}],
}];
const europeCountries: EuropeCountry[] = [{
nameAr: 'النمسا',
nameEn: 'Austria',
population: 8451900,
area: 83855.0,
capitalEn: 'Vienna',
capitalAr: 'فيينا',
}, {
nameAr: 'بلجيكا',
nameEn: 'Belgium',
population: 11161600,
area: 30528.0,
capitalEn: 'Brussels',
capitalAr: 'بروكسل',
}, {
nameAr: 'بلغاريا',
nameEn: 'Bulgaria',
population: 7284600,
area: 110994.0,
capitalEn: 'Sofia',
capitalAr: 'صوفيا',
}, {
nameAr: 'كرواتيا',
nameEn: 'Croatia',
population: 4262100,
area: 56594.0,
capitalEn: 'Zagreb',
capitalAr: 'زغرب',
}];
@Injectable()
export class Service {
getContinents(): Continent[] {
return continents;
}
getEuropeCountries(): EuropeCountry[] {
return europeCountries;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.68/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.8"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
To enable RTL language support in the application, you can either set the globalConfig object's rtlEnabled property to true or specify each component's rtlEnabled property individually. Note that individual RTL parameters have higher priority than general parameters.
In this demo, you can use the language drop-down menu (for example, change the language from English to Arabic) to explore the differences between default and RTL modes.

Backend API
import React, { useCallback, useState } from 'react';
import Accordion from 'devextreme-react/accordion';
import Menu from 'devextreme-react/menu';
import SelectBox from 'devextreme-react/select-box';
import TreeView from 'devextreme-react/tree-view';
import { continents, europeCountries, languageLabel } from './data.ts';
interface Country {
nameAr: string;
nameEn: string;
capitalAr: string;
capitalEn: string;
population: number;
area: number;
}
interface AccordionItem {
nameAr: string;
nameEn: string;
}
const languages = [
'Arabic: Right-to-Left direction',
'English: Left-to-Right direction',
];
const renderArabicTitle = (item: AccordionItem) => (<div>{item.nameAr}</div>);
const renderArabic = (country: Country) => (
<div>
<div>عاصمة: {country.capitalAr} </div>
<div>عدد السكان: {country.population} نسمة</div>
<div>المساحة: {country.area} كم<sup>2</sup></div>
</div>
);
const renderEnglishTitle = (item: AccordionItem) => (<div>{item.nameEn}</div>);
const renderEnglish = (country: Country) => (
<div>
<div>Capital: {country.capitalEn} </div>
<div>Population: {country.population} people</div>
<div>Area: {country.area} km<sup>2</sup></div>
</div>
);
const App = () => {
const [rtlEnabled, setRtl] = useState(false);
const selectLanguage = useCallback(({ value }) => {
setRtl(value === languages[0]);
}, []);
return (
<div className={rtlEnabled ? 'dx-rtl' : ''}>
<div className="options">
<div className="caption">Options</div>
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Language</div>
<div className="dx-field-value">
<SelectBox
items={languages}
inputAttr={languageLabel}
defaultValue={languages[1]}
onValueChanged={selectLanguage}
/>
</div>
</div>
</div>
</div>
<div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">
<Menu
dataSource={continents}
rtlEnabled={rtlEnabled}
displayExpr={rtlEnabled ? 'textAr' : 'text'}
/>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">
<TreeView
width={200}
dataSource={continents}
displayExpr={rtlEnabled ? 'textAr' : 'text'}
rtlEnabled={rtlEnabled}
/>
</div>
<div className="dx-field-value">
<Accordion
dataSource={europeCountries}
rtlEnabled={rtlEnabled}
itemTitleRender={rtlEnabled ? renderArabicTitle : renderEnglishTitle}
itemRender={rtlEnabled ? renderArabic : renderEnglish}
/>
</div>
</div>
</div>
</div>
</div>
);
};
export default App;
import React, { useCallback, useState } from 'react';
import Accordion from 'devextreme-react/accordion';
import Menu from 'devextreme-react/menu';
import SelectBox from 'devextreme-react/select-box';
import TreeView from 'devextreme-react/tree-view';
import { continents, europeCountries, languageLabel } from './data.js';
const languages = ['Arabic: Right-to-Left direction', 'English: Left-to-Right direction'];
const renderArabicTitle = (item) => <div>{item.nameAr}</div>;
const renderArabic = (country) => (
<div>
<div>عاصمة: {country.capitalAr} </div>
<div>عدد السكان: {country.population} نسمة</div>
<div>
المساحة: {country.area} كم<sup>2</sup>
</div>
</div>
);
const renderEnglishTitle = (item) => <div>{item.nameEn}</div>;
const renderEnglish = (country) => (
<div>
<div>Capital: {country.capitalEn} </div>
<div>Population: {country.population} people</div>
<div>
Area: {country.area} km<sup>2</sup>
</div>
</div>
);
const App = () => {
const [rtlEnabled, setRtl] = useState(false);
const selectLanguage = useCallback(({ value }) => {
setRtl(value === languages[0]);
}, []);
return (
<div className={rtlEnabled ? 'dx-rtl' : ''}>
<div className="options">
<div className="caption">Options</div>
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">Language</div>
<div className="dx-field-value">
<SelectBox
items={languages}
inputAttr={languageLabel}
defaultValue={languages[1]}
onValueChanged={selectLanguage}
/>
</div>
</div>
</div>
</div>
<div>
<div className="dx-fieldset">
<div className="dx-fieldset-header">
<Menu
dataSource={continents}
rtlEnabled={rtlEnabled}
displayExpr={rtlEnabled ? 'textAr' : 'text'}
/>
</div>
</div>
<div className="dx-fieldset">
<div className="dx-field">
<div className="dx-field-label">
<TreeView
width={200}
dataSource={continents}
displayExpr={rtlEnabled ? 'textAr' : 'text'}
rtlEnabled={rtlEnabled}
/>
</div>
<div className="dx-field-value">
<Accordion
dataSource={europeCountries}
rtlEnabled={rtlEnabled}
itemTitleRender={rtlEnabled ? renderArabicTitle : renderEnglishTitle}
itemRender={rtlEnabled ? renderArabic : renderEnglish}
/>
</div>
</div>
</div>
</div>
</div>
);
};
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const continents = [{
id: '1',
text: 'Africa',
textAr: 'أفريقيا',
items: [
{
id: '1_2',
text: 'Ethiopia',
textAr: 'أثيوبيا',
items: [{
id: '1_2_1',
text: 'Addis Ababa',
textAr: 'أديس أبابا',
}, {
id: '1_2_2',
text: 'Dire Dawa',
textAr: 'دير داوا',
}],
},
{
id: '1_1',
text: 'Nigeria',
textAr: 'نيجيريا',
items: [{
id: '1_1_1',
text: 'Lagos',
textAr: 'لاغوس',
}, {
id: '1_1_2',
text: 'Kano',
textAr: 'كانو',
}],
},
],
}, {
id: '2',
text: 'Asia',
textAr: 'آسيا',
items: [{
id: '2_1',
text: 'China',
textAr: 'الصين',
items: [{
id: '2_1_1',
text: 'Beijing',
textAr: 'بكين',
}, {
id: '2_1_2',
text: 'Shanghai',
textAr: 'شنغهاي',
}],
}, {
id: '2_2',
text: 'India',
textAr: 'الهند',
items: [{
id: '2_2_1',
text: 'Indianapolis',
textAr: 'انديانابوليس',
}, {
id: '2_2_2',
text: 'New Delhi',
textAr: 'نيودلهي',
}],
}],
}, {
id: '3',
text: 'Australia',
textAr: 'أستراليا',
items: [{
id: '3_1',
text: 'Australia',
textAr: 'أستراليا',
items: [{
id: '3_1_1',
text: 'Canberra',
textAr: 'كانبيرا',
}, {
id: '3_1_2',
text: 'Melbourne',
textAr: 'ملبورن',
}, {
id: '3_1_3',
text: 'Sydney',
textAr: 'سيدني',
}],
}],
}, {
id: '4',
text: 'Europe',
textAr: 'أوروبا',
items: [{
id: '4_1',
text: 'Germany',
textAr: 'ألمانيا',
items: [{
id: '4_1_1',
text: 'Berlin',
textAr: 'البرلينية',
}, {
id: '4_1_2',
text: 'Hamburg',
textAr: 'هامبورغ',
}],
}, {
id: '4_2',
text: 'Russia',
textAr: 'روسيا',
items: [{
id: '4_2_1',
text: 'Moscow',
textAr: 'موسكو',
}, {
id: '4_2_2',
text: 'Saint Petersburg',
textAr: 'سانت بطرسبرغ',
}],
}],
}, {
id: '5',
text: 'North America',
textAr: 'أمريكا الشمالية',
items: [{
id: '5_2',
text: 'Mexico',
textAr: 'المكسيك',
items: [{
id: '5_2_1',
text: 'Mexico City',
textAr: 'مكسيكو سيتي',
}, {
id: '5_2_2',
text: 'Guadalajara',
textAr: 'غوادالاخارا',
}],
}, {
id: '5_1',
text: 'United States',
textAr: 'الولايات المتحدة الأمريكية',
items: [{
id: '5_1_1',
text: 'New York',
textAr: 'نيويورك',
}, {
id: '5_1_2',
text: 'Washington',
textAr: 'واشنطن',
}],
}],
}, {
id: '6',
text: 'South America',
textAr: 'أمريكا الجنوبية',
items: [{
id: '6_1',
text: 'Brazil',
textAr: 'البرازيل',
items: [{
id: '6_1_1',
text: 'Brasilia',
textAr: 'برازيليا',
}, {
id: '6_1_2',
text: 'Sao Paulo',
textAr: 'ساو باولو',
}],
}, {
id: '6_2',
text: 'Colombia',
textAr: 'كولومبيا',
items: [{
id: '6_2_1',
text: 'Bogota',
textAr: 'بوغوتا',
}, {
id: '6_2_2',
text: 'Medellin',
textAr: 'ميديلين',
}],
}],
}];
export const europeCountries = [{
nameAr: 'النمسا',
nameEn: 'Austria',
population: 8451900,
area: 83855.0,
capitalEn: 'Vienna',
capitalAr: 'فيينا',
}, {
nameAr: 'بلجيكا',
nameEn: 'Belgium',
population: 11161600,
area: 30528.0,
capitalEn: 'Brussels',
capitalAr: 'بروكسل',
}, {
nameAr: 'بلغاريا',
nameEn: 'Bulgaria',
population: 7284600,
area: 110994.0,
capitalEn: 'Sofia',
capitalAr: 'صوفيا',
}, {
nameAr: 'كرواتيا',
nameEn: 'Croatia',
population: 4262100,
area: 56594.0,
capitalEn: 'Zagreb',
capitalAr: 'زغرب',
}];
export const languageLabel = { 'aria-label': 'Language' };
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
jsx: 'react',
},
meta: {
'react': {
'esModule': true,
},
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.68/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.8.0/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
react: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const continents = [
{
id: '1',
text: 'Africa',
textAr: 'أفريقيا',
items: [
{
id: '1_2',
text: 'Ethiopia',
textAr: 'أثيوبيا',
items: [
{
id: '1_2_1',
text: 'Addis Ababa',
textAr: 'أديس أبابا',
},
{
id: '1_2_2',
text: 'Dire Dawa',
textAr: 'دير داوا',
},
],
},
{
id: '1_1',
text: 'Nigeria',
textAr: 'نيجيريا',
items: [
{
id: '1_1_1',
text: 'Lagos',
textAr: 'لاغوس',
},
{
id: '1_1_2',
text: 'Kano',
textAr: 'كانو',
},
],
},
],
},
{
id: '2',
text: 'Asia',
textAr: 'آسيا',
items: [
{
id: '2_1',
text: 'China',
textAr: 'الصين',
items: [
{
id: '2_1_1',
text: 'Beijing',
textAr: 'بكين',
},
{
id: '2_1_2',
text: 'Shanghai',
textAr: 'شنغهاي',
},
],
},
{
id: '2_2',
text: 'India',
textAr: 'الهند',
items: [
{
id: '2_2_1',
text: 'Indianapolis',
textAr: 'انديانابوليس',
},
{
id: '2_2_2',
text: 'New Delhi',
textAr: 'نيودلهي',
},
],
},
],
},
{
id: '3',
text: 'Australia',
textAr: 'أستراليا',
items: [
{
id: '3_1',
text: 'Australia',
textAr: 'أستراليا',
items: [
{
id: '3_1_1',
text: 'Canberra',
textAr: 'كانبيرا',
},
{
id: '3_1_2',
text: 'Melbourne',
textAr: 'ملبورن',
},
{
id: '3_1_3',
text: 'Sydney',
textAr: 'سيدني',
},
],
},
],
},
{
id: '4',
text: 'Europe',
textAr: 'أوروبا',
items: [
{
id: '4_1',
text: 'Germany',
textAr: 'ألمانيا',
items: [
{
id: '4_1_1',
text: 'Berlin',
textAr: 'البرلينية',
},
{
id: '4_1_2',
text: 'Hamburg',
textAr: 'هامبورغ',
},
],
},
{
id: '4_2',
text: 'Russia',
textAr: 'روسيا',
items: [
{
id: '4_2_1',
text: 'Moscow',
textAr: 'موسكو',
},
{
id: '4_2_2',
text: 'Saint Petersburg',
textAr: 'سانت بطرسبرغ',
},
],
},
],
},
{
id: '5',
text: 'North America',
textAr: 'أمريكا الشمالية',
items: [
{
id: '5_2',
text: 'Mexico',
textAr: 'المكسيك',
items: [
{
id: '5_2_1',
text: 'Mexico City',
textAr: 'مكسيكو سيتي',
},
{
id: '5_2_2',
text: 'Guadalajara',
textAr: 'غوادالاخارا',
},
],
},
{
id: '5_1',
text: 'United States',
textAr: 'الولايات المتحدة الأمريكية',
items: [
{
id: '5_1_1',
text: 'New York',
textAr: 'نيويورك',
},
{
id: '5_1_2',
text: 'Washington',
textAr: 'واشنطن',
},
],
},
],
},
{
id: '6',
text: 'South America',
textAr: 'أمريكا الجنوبية',
items: [
{
id: '6_1',
text: 'Brazil',
textAr: 'البرازيل',
items: [
{
id: '6_1_1',
text: 'Brasilia',
textAr: 'برازيليا',
},
{
id: '6_1_2',
text: 'Sao Paulo',
textAr: 'ساو باولو',
},
],
},
{
id: '6_2',
text: 'Colombia',
textAr: 'كولومبيا',
items: [
{
id: '6_2_1',
text: 'Bogota',
textAr: 'بوغوتا',
},
{
id: '6_2_2',
text: 'Medellin',
textAr: 'ميديلين',
},
],
},
],
},
];
export const europeCountries = [
{
nameAr: 'النمسا',
nameEn: 'Austria',
population: 8451900,
area: 83855.0,
capitalEn: 'Vienna',
capitalAr: 'فيينا',
},
{
nameAr: 'بلجيكا',
nameEn: 'Belgium',
population: 11161600,
area: 30528.0,
capitalEn: 'Brussels',
capitalAr: 'بروكسل',
},
{
nameAr: 'بلغاريا',
nameEn: 'Bulgaria',
population: 7284600,
area: 110994.0,
capitalEn: 'Sofia',
capitalAr: 'صوفيا',
},
{
nameAr: 'كرواتيا',
nameEn: 'Croatia',
population: 4262100,
area: 56594.0,
capitalEn: 'Zagreb',
capitalAr: 'زغرب',
},
];
export const languageLabel = { 'aria-label': 'Language' };
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.6/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
sup {
font-size: 0.8em;
vertical-align: super;
line-height: 0;
}
.options {
padding: 20px;
background-color: rgba(191, 191, 191, 0.15);
margin-bottom: 20px;
}
.options .dx-fieldset {
margin: 0;
}
.caption {
font-size: 18px;
font-weight: 500;
padding-right: 15px;
}
.dx-theme-material .dx-accordion .dx-accordion-item-opened .dx-accordion-item-title {
padding-top: 20px;
}
To enable RTL language support in the application, you can either set the globalConfig object's rtlEnabled property to true or specify each component's rtlEnabled property individually. Note that individual RTL parameters have higher priority than general parameters.
In this demo, you can use the language drop-down menu (for example, change the language from English to Arabic) to explore the differences between default and RTL modes.